Index: modules/core/m_sjoin.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/Attic/m_sjoin.c,v
retrieving revision 1.201.2.2
diff -b -u -r1.201.2.2 m_sjoin.c
--- modules/core/m_sjoin.c	14 Aug 2004 21:43:57 -0000	1.201.2.2
+++ modules/core/m_sjoin.c	19 Aug 2004 22:16:29 -0000
@@ -49,6 +49,7 @@
 };
 
 mapi_clist_av1 sjoin_clist[] = { &sjoin_msgtab, NULL };
+
 DECLARE_MODULE_AV1(sjoin, NULL, NULL, sjoin_clist, NULL, NULL, "$Revision: 1.201.2.2 $");
 
 /*
@@ -74,7 +75,7 @@
 static void set_final_mode(struct Mode *mode, struct Mode *oldmode);
 static void remove_our_modes(struct Channel *chptr, struct Client *source_p);
 static void remove_ban_list(struct Channel *chptr, struct Client *source_p,
-			    dlink_list *list, char c, int cap);
+			    dlink_list * list, char c, int cap);
 
 static int
 ms_sjoin(struct Client *client_p, struct Client *source_p, int parc, const char *parv[])
@@ -123,7 +124,7 @@
 	newts = atol(parv[1]);
 
 	s = parv[3];
-	while (*s)
+	while(*s)
 	{
 		switch (*(s++))
 		{
@@ -163,7 +164,7 @@
 	s = parv[args + 4];
 
 	/* remove any leading spaces */
-	while (*s == ' ')
+	while(*s == ' ')
 		s++;
 
 	if(EmptyString(s))
@@ -238,8 +239,7 @@
 
 	if(*modebuf != '\0')
 		sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s %s %s",
-				     source_p->name, chptr->chname, 
-				     modebuf, parabuf);
+				     source_p->name, chptr->chname, modebuf, parabuf);
 
 	*modebuf = *parabuf = '\0';
 
@@ -254,16 +254,14 @@
 	}
 
 	mlen = ircsprintf(buf_nick, ":%s SJOIN %ld %s %s %s:",
-			  source_p->name, (long) chptr->channelts,
-			  parv[2], modebuf, parabuf);
+			  source_p->name, (long) chptr->channelts, parv[2], modebuf, parabuf);
 	ptr_nick = buf_nick + mlen;
 
 	/* working on the presumption eventually itll be more efficient to
 	 * build a TS6 buffer without checking its needed..
 	 */
 	mlen = ircsprintf(buf_uid, ":%s SJOIN %ld %s %s %s:",
-			  use_id(source_p), (long) chptr->channelts,
-			  parv[2], modebuf, parabuf);
+			  use_id(source_p), (long) chptr->channelts, parv[2], modebuf, parabuf);
 	ptr_uid = buf_uid + mlen;
 
 	mbuf = modebuf;
@@ -282,17 +280,22 @@
 		*p++ = '\0';
 	}
 
-	while (s)
+	while(s)
 	{
 		fl = 0;
 
-		for (i = 0; i < 2; i++)
+		for(i = 0; i < 2; i++)
 		{
 			if(*s == '@')
 			{
 				fl |= CHFL_CHANOP;
 				s++;
 			}
+			else if(*s == '%')
+			{
+				fl |= CHFL_HALFOP;
+				s++;
+			}
 			else if(*s == '+')
 			{
 				fl |= CHFL_VOICE;
@@ -311,8 +314,7 @@
 		if((mlen + len_nick + NICKLEN + 3) > (BUFSIZE - 3))
 		{
 			*(ptr_nick - 1) = '\0';
-			sendto_server(client_p->from, NULL, NOCAPS, CAP_TS6,
-				      "%s", buf_nick);
+			sendto_server(client_p->from, NULL, NOCAPS, CAP_TS6, "%s", buf_nick);
 			ptr_nick = buf_nick + mlen;
 			len_nick = 0;
 		}
@@ -320,8 +322,7 @@
 		if((mlen + len_uid + IDLEN + 3) > (BUFSIZE - 3))
 		{
 			*(ptr_uid - 1) = '\0';
-			sendto_server(client_p->from, NULL, CAP_TS6, NOCAPS,
-				      "%s", buf_uid);
+			sendto_server(client_p->from, NULL, CAP_TS6, NOCAPS, "%s", buf_uid);
 			ptr_uid = buf_uid + mlen;
 			len_uid = 0;
 		}
@@ -335,6 +336,13 @@
 				len_nick++;
 				len_uid++;
 			}
+			if(fl & CHFL_HALFOP)
+			{
+				*ptr_nick++ = '%';
+				*ptr_uid++ = '%';
+				len_nick++;
+				len_uid++;
+			}
 			if(fl & CHFL_VOICE)
 			{
 				*ptr_nick++ = '+';
@@ -356,6 +364,8 @@
 		{
 			if(fl & CHFL_CHANOP)
 				fl = CHFL_DEOPPED;
+			if(fl & CHFL_HALFOP)
+				fl = CHFL_DEOPPED;
 			else
 				fl = 0;
 		}
@@ -398,6 +408,11 @@
 				para[pargs++] = target_p->name;
 			}
 		}
+		else if(fl & CHFL_HALFOP)
+		{
+			*mbuf++ = 'h';
+			para[pargs++] = target_p->name;
+		}
 		else if(fl & CHFL_VOICE)
 		{
 			*mbuf++ = 'v';
@@ -445,7 +460,8 @@
 		sendto_channel_local(ALL_MEMBERS, chptr,
 				     ":%s MODE %s %s %s %s %s %s",
 				     source_p->name, chptr->chname, modebuf,
-				     para[0], CheckEmpty(para[1]), CheckEmpty(para[2]), CheckEmpty(para[3]));
+				     para[0], CheckEmpty(para[1]), CheckEmpty(para[2]),
+				     CheckEmpty(para[3]));
 	}
 
 	if(!joins)
@@ -459,10 +475,8 @@
 	*(ptr_nick - 1) = '\0';
 	*(ptr_uid - 1) = '\0';
 
-	sendto_server(client_p->from, NULL, CAP_TS6, NOCAPS,
-		      "%s", buf_uid);
-	sendto_server(client_p->from, NULL, NOCAPS, CAP_TS6,
-		      "%s", buf_nick);
+	sendto_server(client_p->from, NULL, CAP_TS6, NOCAPS, "%s", buf_uid);
+	sendto_server(client_p->from, NULL, NOCAPS, CAP_TS6, "%s", buf_nick);
 
 	/* if the source does TS6 we have to remove our bans.  Its now safe
 	 * to issue -b's to the non-ts6 servers, as the sjoin we've just
@@ -471,16 +485,13 @@
 	if(!keep_our_modes && source_p->id[0] != '\0')
 	{
 		if(dlink_list_length(&chptr->banlist) > 0)
-			remove_ban_list(chptr, source_p, &chptr->banlist,
-					'b', NOCAPS);
+			remove_ban_list(chptr, source_p, &chptr->banlist, 'b', NOCAPS);
 
 		if(dlink_list_length(&chptr->exceptlist) > 0)
-			remove_ban_list(chptr, source_p, &chptr->exceptlist,
-					'e', CAP_EX);
+			remove_ban_list(chptr, source_p, &chptr->exceptlist, 'e', CAP_EX);
 
 		if(dlink_list_length(&chptr->invexlist) > 0)
-			remove_ban_list(chptr, source_p, &chptr->invexlist,
-					'I', CAP_IE);
+			remove_ban_list(chptr, source_p, &chptr->invexlist, 'I', CAP_IE);
 	}
 
 	
@@ -512,7 +523,7 @@
 	int i;
 
 	/* ok, first get a list of modes we need to add */
-	for (i = 0; flags[i].letter; i++)
+	for(i = 0; flags[i].letter; i++)
 	{
 		if((mode->mode & flags[i].mode) && !(oldmode->mode & flags[i].mode))
 		{
@@ -526,7 +537,7 @@
 	}
 
 	/* now the ones we need to remove. */
-	for (i = 0; flags[i].letter; i++)
+	for(i = 0; flags[i].letter; i++)
 	{
 		if((oldmode->mode & flags[i].mode) && !(mode->mode & flags[i].mode))
 		{
@@ -646,6 +657,12 @@
 				*mbuf++ = 'v';
 			}
 		}
+		else if(is_halfop(msptr))
+		{
+			msptr->flags &= ~CHFL_HALFOP;
+			lpara[count++] = msptr->client_p->name;
+			*mbuf++ = 'h';
+		}
 		else if(is_voiced(msptr))
 		{
 			msptr->flags &= ~CHFL_VOICE;
@@ -693,8 +710,7 @@
  * 		  and non-TS6 servers.
  */
 static void
-remove_ban_list(struct Channel *chptr, struct Client *source_p,
-		dlink_list *list, char c, int cap)
+remove_ban_list(struct Channel *chptr, struct Client *source_p, dlink_list * list, char c, int cap)
 {
 	static char lmodebuf[BUFSIZE];
 	static char lparabuf[BUFSIZE];
@@ -707,8 +723,7 @@
 
 	pbuf = lparabuf;
 
-	cur_len = mlen = ircsprintf(lmodebuf, ":%s MODE %s -", 
-				    source_p->name, chptr->chname);
+	cur_len = mlen = ircsprintf(lmodebuf, ":%s MODE %s -", source_p->name, chptr->chname);
 	mbuf = lmodebuf + mlen;
 
 	DLINK_FOREACH_SAFE(ptr, next_ptr, list->head)
@@ -723,10 +738,8 @@
 			/* remove trailing space */
 			*(pbuf - 1) = '\0';
 
-			sendto_channel_local(ALL_MEMBERS, chptr, "%s%s",
-					     lmodebuf, lparabuf);
-			sendto_server(source_p, chptr, cap, CAP_TS6,
-				      "%s%s", lmodebuf, lparabuf);
+			sendto_channel_local(ALL_MEMBERS, chptr, "%s%s", lmodebuf, lparabuf);
+			sendto_server(source_p, chptr, cap, CAP_TS6, "%s%s", lmodebuf, lparabuf);
 
 			cur_len = mlen;
 			mbuf = lmodebuf + mlen;
@@ -743,8 +756,7 @@
 
 	*(pbuf - 1) = '\0';
 	sendto_channel_local(ALL_MEMBERS, chptr, "%s%s", lmodebuf, lparabuf);
-	sendto_server(source_p, chptr, cap, CAP_TS6,
-		      "%s%s", lmodebuf, lparabuf);
+	sendto_server(source_p, chptr, cap, CAP_TS6, "%s%s", lmodebuf, lparabuf);
 
 	list->head = list->tail = NULL;
 	list->length = 0;
Index: modules/core/m_squit.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/m_squit.c,v
retrieving revision 1.79
diff -b -u -r1.79 m_squit.c
--- modules/core/m_squit.c	15 Mar 2004 17:58:06 -0000	1.79
+++ modules/core/m_squit.c	19 Aug 2004 22:16:29 -0000
@@ -49,6 +49,7 @@
 };
 
 mapi_clist_av1 squit_clist[] = { &squit_msgtab, NULL };
+
 DECLARE_MODULE_AV1(squit, NULL, NULL, squit_clist, NULL, NULL, "$Revision: 1.79 $");
 
 struct squit_parms
@@ -75,8 +76,7 @@
 
 	if(!IsOperRemote(source_p))
 	{
-		sendto_one(source_p, form_str(ERR_NOPRIVS),
-			   me.name, source_p->name, "remote");
+		sendto_one(source_p, form_str(ERR_NOPRIVS), me.name, source_p->name, "remote");
 		return 0;
 	}
 
@@ -97,8 +97,7 @@
 	}
 	else
 	{
-		sendto_one_numeric(source_p, ERR_NOSUCHSERVER,
-				   form_str(ERR_NOSUCHSERVER), parv[1]);
+		sendto_one_numeric(source_p, ERR_NOSUCHSERVER, form_str(ERR_NOSUCHSERVER), parv[1]);
 	}
 
 	return 0;
@@ -141,8 +140,7 @@
 			      ":%s WALLOPS :Remote SQUIT %s from %s (%s)",
 			      me.name, target_p->name, source_p->name, comment);
 
-		ilog(L_SERVER, "SQUIT From %s : %s (%s)", parv[0],
-		     target_p->name, comment);
+		ilog(L_SERVER, "SQUIT From %s : %s (%s)", parv[0], target_p->name, comment);
 
 	}
 	exit_client(client_p, target_p, source_p, comment);
Index: src/adns.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/adns.c,v
retrieving revision 7.69.4.1
diff -b -u -r7.69.4.1 adns.c
--- src/adns.c	3 Aug 2004 20:39:50 -0000	7.69.4.1
+++ src/adns.c	19 Aug 2004 22:16:29 -0000
@@ -51,11 +51,10 @@
 {
 	int x;
 	char buf[16];		/* XXX: adns only deals with ipv4 dns servers so this is okay */
-	for (x = 0; x < dns_state->nservers; x++)
+	for(x = 0; x < dns_state->nservers; x++)
 	{
 		inetntop(AF_INET, &dns_state->servers[x].addr.s_addr, buf, 16);
-		sendto_one_numeric(source_p, RPL_STATSALINE, 
-				   form_str(RPL_STATSALINE), buf);
+		sendto_one_numeric(source_p, RPL_STATSALINE, form_str(RPL_STATSALINE), buf);
 	}
 }
 
@@ -153,7 +152,7 @@
 	int failure = 0;
 	adns_forallqueries_begin(dns_state);
 
-	while ((q = adns_forallqueries_next(dns_state, xr)) != NULL)
+	while((q = adns_forallqueries_next(dns_state, xr)) != NULL)
 	{
 		switch (adns_check(dns_state, &q, &answer, xq))
 		{
@@ -187,7 +186,8 @@
 	}
         if(failure == 1)
         {       
-	        sendto_realops_flags(UMODE_ALL, L_ALL, "adns got a global system failure..attempting to restart resolver");
+		sendto_realops_flags(UMODE_ALL, L_ALL,
+				     "adns got a global system failure..attempting to restart resolver");
                 init_resolver();
         }
 }
@@ -219,7 +219,7 @@
 	int npollfds, i, fd;
 	adns__consistency(dns_state, 0, cc_entex);
 	npollfds = adns__pollfds(dns_state, pollfds);
-	for (i = 0; i < npollfds; i++)
+	for(i = 0; i < npollfds; i++)
 	{
 		fd = pollfds[i].fd;
 		if(pollfds[i].events & ADNS_POLLIN)
@@ -243,7 +243,8 @@
 	assert(dns_state->nservers > 0);
 #ifdef IPV6
 	if(aftype == AF_INET6)
-		result = adns_submit(dns_state, name, adns_r_addr6, adns_qf_owner, req, &req->query);
+		result = adns_submit(dns_state, name, adns_r_addr6, adns_qf_owner, req,
+				     &req->query);
 	else
 #endif
 		result = adns_submit(dns_state, name, adns_r_addr, adns_qf_owner, req, &req->query);
Index: src/balloc.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/balloc.c,v
retrieving revision 7.82
diff -b -u -r7.82 balloc.c
--- src/balloc.c	20 Jul 2004 19:29:46 -0000	7.82
+++ src/balloc.c	19 Aug 2004 22:16:30 -0000
@@ -122,12 +122,12 @@
 #ifdef DEBUG_BALLOC
 /* Check the list length the very slow way */
 static unsigned long
-slow_list_length(dlink_list *list)
+slow_list_length(dlink_list * list)
 {
 	dlink_node *ptr;
 	unsigned long count = 0;
     
-	for (ptr = list->head; ptr; ptr = ptr->next)
+	for(ptr = list->head; ptr; ptr = ptr->next)
 	{
 		count++;
 		if(count > list->length * 2)
@@ -139,7 +139,7 @@
 }
 
 static void
-bh_sanity_check_block(BlockHeap *bh, Block *block)
+bh_sanity_check_block(BlockHeap * bh, Block * block)
 {
 	unsigned long s_used, s_free;
 	s_used = slow_list_length(&block->used_list);
@@ -149,14 +149,15 @@
 	if(s_free != dlink_list_length(&block->free_list))
 		blockheap_fail("free link count doesn't match head count");
 	
-	if(dlink_list_length(&block->used_list) + dlink_list_length(&block->free_list) != bh->elemsPerBlock)
+	if(dlink_list_length(&block->used_list) + dlink_list_length(&block->free_list) !=
+	   bh->elemsPerBlock)
 		blockheap_fail("used_list + free_list != elemsPerBlock");
 }
 
 #if 0
 /* See how confused we are */
 static void
-bh_sanity_check(BlockHeap *bh)
+bh_sanity_check(BlockHeap * bh)
 {
 	Block *walker;
 	unsigned long real_alloc = 0;
@@ -179,7 +180,8 @@
 		if(s_free != dlink_list_length(&walker->free_list))
 			blockheap_fail("free link count doesn't match head count");
 		
-		if(dlink_list_length(&walker->used_list) + dlink_list_length(&walker->free_list) != bh->elemsPerBlock)
+		if(dlink_list_length(&walker->used_list) + dlink_list_length(&walker->free_list) !=
+		   bh->elemsPerBlock)
 			blockheap_fail("used_list + free_list != elemsPerBlock");
 
 		real_alloc += dlink_list_length(&walker->used_list);
@@ -307,7 +309,7 @@
 	}
 	offset = b->elems;
 	/* Setup our blocks now */
-	for (i = 0; i < bh->elemsPerBlock; i++)
+	for(i = 0; i < bh->elemsPerBlock; i++)
 	{
 		void *data;
 		newblk = (void *) offset;
@@ -430,13 +432,14 @@
 			BlockHeapGarbageCollect(bh);
 			if(bh->freeElems == 0)
 			{
-				ilog(L_MAIN, "newblock() failed and garbage collection didn't help");
+				ilog(L_MAIN,
+				     "newblock() failed and garbage collection didn't help");
 				outofmemory();	/* Well that didn't work either...bail */
 			}
 		}
 	}
 
-	for (walker = bh->base; walker != NULL; walker = walker->next)
+	for(walker = bh->base; walker != NULL; walker = walker->next)
 	{
 		if(dlink_list_length(&walker->free_list) > 0)
 		{
@@ -448,16 +451,19 @@
 			dlinkMoveNode(new_node, &walker->free_list, &walker->used_list);
 			s_assert(new_node->data != NULL);
 			if(new_node->data == NULL)
-				blockheap_fail("new_node->data is NULL and that shouldn't happen!!!");
+				blockheap_fail
+					("new_node->data is NULL and that shouldn't happen!!!");
 			memset(new_node->data, 0, bh->elemSize);
 #ifdef DEBUG_BALLOC
 			do
 			{
-				struct MemBlock *memblock = (void *) ((size_t) new_node->data - sizeof(MemBlock));
+				struct MemBlock *memblock =
+					(void *) ((size_t) new_node->data - sizeof(MemBlock));
 				if(memblock->magic == BALLOC_FREE_MAGIC)
 					memblock->magic = BALLOC_MAGIC;
 			
-			} while(0);
+			}
+			while(0);
 			bh_sanity_check_block(bh, walker);
 #endif
 			return (new_node->data);
@@ -507,8 +513,8 @@
 	{
 		blockheap_fail("double free of a block");
 		outofmemory();
-	} else 
-	if(memblock->magic != BALLOC_MAGIC)
+	}
+	else if(memblock->magic != BALLOC_MAGIC)
 	{
 		blockheap_fail("memblock->magic != BALLOC_MAGIC");
 		outofmemory();
@@ -564,7 +570,7 @@
 	last = NULL;
 	walker = bh->base;
 
-	while (walker != NULL)
+	while(walker != NULL)
 	{
 		if((dlink_list_length(&walker->free_list) == bh->elemsPerBlock) != 0)
 		{
@@ -615,7 +621,7 @@
 		return (1);
 	}
 
-	for (walker = bh->base; walker != NULL; walker = next)
+	for(walker = bh->base; walker != NULL; walker = next)
 	{
 		next = walker->next;
 		free_block(walker->elems, walker->alloc_size);
@@ -651,4 +657,3 @@
 }
 
 #endif /* NOBALLOC */
-
Index: src/cache.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/cache.c,v
retrieving revision 1.13
diff -b -u -r1.13 cache.c
--- src/cache.c	30 Mar 2004 17:24:08 -0000	1.13
+++ src/cache.c	19 Aug 2004 22:16:30 -0000
@@ -109,8 +109,7 @@
 			ircsnprintf(user_motd_changed, sizeof(user_motd_changed),
 				 "%d/%d/%d %d:%d",
 				 local_tm->tm_mday, local_tm->tm_mon + 1,
-				 1900 + local_tm->tm_year, local_tm->tm_hour,
-				 local_tm->tm_min);
+				    1900 + local_tm->tm_year, local_tm->tm_hour, local_tm->tm_min);
 	}
 
 	cacheptr = BlockHeapAlloc(cachefile_heap);
@@ -160,16 +159,14 @@
 		target_p = ptr->data;
 
 		/* skip ourselves (done in /links) and hidden servers */
-		if(IsMe(target_p) ||
-		   (IsHidden(target_p) && !ConfigServerHide.disable_hidden))
+		if(IsMe(target_p) || (IsHidden(target_p) && !ConfigServerHide.disable_hidden))
 			continue;
 
 		/* if the below is ever modified, change LINKSLINELEN */
 		links_line = MyMalloc(LINKSLINELEN);
 		ircsnprintf(links_line, LINKSLINELEN, "%s %s :1 %s",
 			   target_p->name, me.name, 
-			   target_p->info[0] ? target_p->info : 
-			    "(Unknown Location)");
+			    target_p->info[0] ? target_p->info : "(Unknown Location)");
 
 		dlinkAddTailAlloc(links_line, &links_cache_list);
 	}
@@ -209,7 +206,7 @@
 load_help(void)
 {
 	DIR *helpfile_dir = NULL;
-	struct dirent *ldirent= NULL;
+	struct dirent *ldirent = NULL;
 	char filename[MAXPATHLEN];
 	struct cachefile *cacheptr;
 
@@ -311,17 +308,13 @@
 	if(oper_motd == NULL || dlink_list_length(&oper_motd->contents) == 0)
 		return;
 
-	sendto_one(source_p, form_str(RPL_OMOTDSTART), 
-		   me.name, source_p->name);
+	sendto_one(source_p, form_str(RPL_OMOTDSTART), me.name, source_p->name);
 
 	DLINK_FOREACH(ptr, oper_motd->contents.head)
 	{
 		lineptr = ptr->data;
-		sendto_one(source_p, form_str(RPL_OMOTD),
-			   me.name, source_p->name, lineptr->data);
+		sendto_one(source_p, form_str(RPL_OMOTD), me.name, source_p->name, lineptr->data);
 	}
 
-	sendto_one(source_p, form_str(RPL_ENDOFOMOTD), 
-		   me.name, source_p->name);
+	sendto_one(source_p, form_str(RPL_ENDOFOMOTD), me.name, source_p->name);
 }
-
Index: src/channel.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/channel.c,v
retrieving revision 7.417.2.2
diff -b -u -r7.417.2.2 channel.c
--- src/channel.c	2 Aug 2004 21:15:43 -0000	7.417.2.2
+++ src/channel.c	19 Aug 2004 22:16:30 -0000
@@ -54,6 +54,7 @@
 static BlockHeap *member_heap;
 
 static int channel_capabs[] = { CAP_EX, CAP_IE, CAP_TS6 };
+
 #define NCHCAPS         (sizeof(channel_capabs)/sizeof(int))
 #define NCHCAP_COMBOS   (1 << NCHCAPS)
 
@@ -85,7 +86,7 @@
 	struct Channel *chptr;
 	chptr = BlockHeapAlloc(channel_heap);
 	DupNString(chptr->chname, chname, CHANNELLEN);
-	return(chptr);
+	return (chptr);
 }
 
 void
@@ -103,7 +104,7 @@
 	DupNString(bptr->banstr, banstr, BANLEN);
 	DupNString(bptr->who, who, BANLEN);
 	
-	return(bptr);
+	return (bptr);
 }
 
 void
@@ -147,7 +148,7 @@
  * side effects -
  */
 const char *
-find_channel_status(struct membership *msptr, int combine)
+find_channel_status(struct membership *msptr, int combine, int halfop)
 {
 	static char buffer[3];
 	char *p;
@@ -161,6 +162,25 @@
 		*p++ = '@';
 	}
 
+	if(is_halfop(msptr))
+	{
+		/* if we're not combining, this isn't getting sent
+		 * to a remote server; don't worry about the capab
+		 * check.
+		 */
+		if(!combine)
+		{
+			if(halfop)
+				return "%";
+			else
+				return "@";
+		}
+		if(halfop)
+			*p++ = '%';
+		else
+			*p++ = '@';
+	}
+
 	if(is_voiced(msptr))
 		*p++ = '+';
 
@@ -285,7 +305,7 @@
 	if(name == NULL)
 		return 0;
 
-	for (; *name; ++name)
+	for(; *name; ++name)
 	{
 		if(!IsChanChar(*name))
 			return 0;
@@ -301,7 +321,7 @@
  * side effects - list of b/e/I modes is cleared
  */
 void
-free_channel_list(dlink_list *list)
+free_channel_list(dlink_list * list)
 {
 	dlink_node *ptr;
 	dlink_node *next_ptr;
@@ -387,8 +407,7 @@
 
 		cur_len = mlen = ircsprintf(lbuf, form_str(RPL_NAMREPLY),
 					    me.name, client_p->name, 
-					    channel_pub_or_secret(chptr),
-					    chptr->chname);
+					    channel_pub_or_secret(chptr), chptr->chname);
 
 		t = lbuf + cur_len;
 
@@ -412,8 +431,7 @@
 				t = lbuf + mlen;
 			}
 
-			ircsprintf(t, "%s%s ", find_channel_status(msptr, 0),
-				   target_p->name);
+			ircsprintf(t, "%s%s ", find_channel_status(msptr, 0, 1), target_p->name);
 
 			cur_len += tlen;
 			t += tlen;
@@ -464,10 +482,8 @@
 	/* if the buffers havent been built, do it here */
 	if(s == NULL)
 	{
-		ircsprintf(src_host, "%s!%s@%s",
-			   who->name, who->username, who->host);
-		ircsprintf(src_iphost, "%s!%s@%s",
-			   who->name, who->username, who->sockhost);
+		ircsprintf(src_host, "%s!%s@%s", who->name, who->username, who->host);
+		ircsprintf(src_iphost, "%s!%s@%s", who->name, who->username, who->sockhost);
 
 		s = src_host;
 		s2 = src_iphost;
@@ -477,8 +493,7 @@
 	{
 		actualBan = ptr->data;
 		if(match(actualBan->banstr, s) ||
-		   match(actualBan->banstr, s2) || 
-		   match_cidr(actualBan->banstr, s2))
+		   match(actualBan->banstr, s2) || match_cidr(actualBan->banstr, s2))
 			break;
 		else
 			actualBan = NULL;
@@ -492,8 +507,7 @@
 
 			/* theyre exempted.. */
 			if(match(actualExcept->banstr, s) ||
-			   match(actualExcept->banstr, s2) || 
-			   match_cidr(actualExcept->banstr, s2))
+			   match(actualExcept->banstr, s2) || match_cidr(actualExcept->banstr, s2))
 			{
 				/* cache the fact theyre not banned */
 				if(msptr != NULL)
@@ -544,10 +558,8 @@
 
 	s_assert(source_p->localClient != NULL);
 
-	ircsprintf(src_host, "%s!%s@%s", 
-		   source_p->name, source_p->username, source_p->host);
-	ircsprintf(src_iphost, "%s!%s@%s",
-		   source_p->name, source_p->username, source_p->sockhost);
+	ircsprintf(src_host, "%s!%s@%s", source_p->name, source_p->username, source_p->host);
+	ircsprintf(src_iphost, "%s!%s@%s", source_p->name, source_p->username, source_p->sockhost);
 
 	if((is_banned(chptr, source_p, NULL, src_host, src_iphost)) == CHFL_BAN)
 		return (ERR_BANNEDFROMCHAN);
@@ -580,7 +592,7 @@
 		return (ERR_BADCHANNELKEY);
 
 	if(chptr->mode.limit && 
-	   dlink_list_length(&chptr->members) >= (unsigned long)chptr->mode.limit)
+	   dlink_list_length(&chptr->members) >= (unsigned long) chptr->mode.limit)
 		return (ERR_CHANNELISFULL);
 
 	return 0;
@@ -593,8 +605,7 @@
  * side effects -
  */
 int
-can_send(struct Channel *chptr, struct Client *source_p, 
-	 struct membership *msptr)
+can_send(struct Channel *chptr, struct Client *source_p, struct membership *msptr)
 {
 	if(IsServer(source_p))
 		return CAN_SEND_OPV;
@@ -613,8 +624,7 @@
 			 * they cant send.  we dont check bans here because
 			 * theres no possibility of caching them --fl
 			 */
-			if(chptr->mode.mode & MODE_NOPRIVMSGS ||
-			   chptr->mode.mode & MODE_MODERATED)
+			if(chptr->mode.mode & MODE_NOPRIVMSGS || chptr->mode.mode & MODE_MODERATED)
 				return CAN_SEND_NO;
 			else
 				return CAN_SEND_NONOP;
@@ -724,8 +734,7 @@
 
 	splitmode = 0;
 
-	sendto_realops_flags(UMODE_ALL, L_ALL,
-			     "Network rejoined, deactivating splitmode");
+	sendto_realops_flags(UMODE_ALL, L_ALL, "Network rejoined, deactivating splitmode");
 }
 
 /* check_splitmode()
@@ -741,7 +750,7 @@
 	if(splitchecking && (ConfigChannel.no_join_on_split || ConfigChannel.no_create_on_split))
 	{
 		if(!splitmode && 
-		   ((dlink_list_length(&global_serv_list) < (unsigned long)split_servers) ||
+		   ((dlink_list_length(&global_serv_list) < (unsigned long) split_servers) ||
 		    (Count.total < split_users)))
 		{
 			splitmode = 1;
@@ -751,7 +760,7 @@
 			eventAddIsh("check_splitmode", check_splitmode, NULL, 10);
 		}
 		else if(splitmode && 
-			(dlink_list_length(&global_serv_list) >= (unsigned long)split_servers) &&
+			(dlink_list_length(&global_serv_list) >= (unsigned long) split_servers) &&
 			(Count.total >= split_users))
 		{
 			/* splitmode ended, if we're delaying the
@@ -825,8 +834,7 @@
  * side effects - channels topic, topic info and TS are set.
  */
 void
-set_channel_topic(struct Channel *chptr, const char *topic,
-		  const char *topic_info, time_t topicts)
+set_channel_topic(struct Channel *chptr, const char *topic, const char *topic_info, time_t topicts)
 {
 	if(strlen(topic) > 0)
 	{
@@ -917,10 +925,10 @@
 	memset(chcap_combos, 0, sizeof(chcap_combos));
 
 	/* For every possible combination */
-	for (m = 0; m < NCHCAP_COMBOS; m++)
+	for(m = 0; m < NCHCAP_COMBOS; m++)
 	{
 		/* Check each capab */
-		for (c = y = n = 0; c < NCHCAPS; c++)
+		for(c = y = n = 0; c < NCHCAPS; c++)
 		{
 			if((m & (1 << c)) == 0)
 				n |= channel_capabs[c];
@@ -943,7 +951,7 @@
 {
 	int n;
 
-	for (n = 0; n < NCHCAP_COMBOS; n++)
+	for(n = 0; n < NCHCAP_COMBOS; n++)
 	{
 		if(IsCapable(serv_p, chcap_combos[n].cap_yes) &&
 		   NotCapable(serv_p, chcap_combos[n].cap_no))
@@ -969,7 +977,7 @@
 {
 	int n;
 
-	for (n = 0; n < NCHCAP_COMBOS; n++)
+	for(n = 0; n < NCHCAP_COMBOS; n++)
 	{
 		if(IsCapable(serv_p, chcap_combos[n].cap_yes) &&
 		   NotCapable(serv_p, chcap_combos[n].cap_no))
@@ -1001,8 +1009,7 @@
  */
 void
 send_cap_mode_changes(struct Client *client_p, struct Client *source_p,
-		      struct Channel *chptr, struct ChModeChange mode_changes[],
-		      int mode_count)
+		      struct Channel *chptr, struct ChModeChange mode_changes[], int mode_count)
 {
 	static char modebuf[BUFSIZE];
 	static char parabuf[MODEBUFLEN];
@@ -1016,7 +1023,7 @@
 	int arglen;
 
 	/* Now send to servers... */
-	for (j = 0; j < NCHCAP_COMBOS; j++)
+	for(j = 0; j < NCHCAP_COMBOS; j++)
 	{
 		if(chcap_combos[j].count == 0)
 			continue;
@@ -1040,17 +1047,26 @@
 						source_p->name, chptr->chname);
 
 		/* loop the list of - modes we have */
-		for (i = 0; i < mode_count; i++)
+		for(i = 0; i < mode_count; i++)
 		{
 			/* if they dont support the cap we need, or they do support a cap they
 			 * cant have, then dont add it to the modebuf.. that way they wont see
 			 * the mode
 			 */
-			if((mode_changes[i].letter == 0) ||
+			if(((mode_changes[i].letter == 0) ||
 				((cap & mode_changes[i].caps) != mode_changes[i].caps)
 				|| ((nocap & mode_changes[i].nocaps) != mode_changes[i].nocaps))
+			   && (mode_changes[i].caps != CAP_HOPS))
 				continue;
 
+			if((cap & CAP_HOPS) && (mode_changes[i].caps != CAP_HOPS))
+			{
+				/* we're sending to a server that doesn't
+				 * support halfops, send an equivalent. 
+				 */
+				mode_changes[i].letter = 'o';
+			}
+
 			if((cap & CAP_TS6) && !EmptyString(mode_changes[i].id))
 				arg = mode_changes[i].id;
 			else
@@ -1061,7 +1077,7 @@
 				arglen = strlen(arg);
 
 				/* dont even think about it! --fl */
-				if(arglen > MODEBUFLEN-5)
+				if(arglen > MODEBUFLEN - 5)
 					continue;
 			}
 
@@ -1074,7 +1090,7 @@
 			 */
 			if(arg && ((mc == MAXMODEPARAMS) ||
 				(arglen + pbl + 3) > sizeof(parabuf) ||
-				(arglen + pbl + mbl + 4) > BUFSIZE-5))
+				   (arglen + pbl + mbl + 4) > BUFSIZE - 5))
 			{
 				if(nc != 0)
 					sendto_server(client_p, chptr, cap, nocap,
Index: src/class.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/class.c,v
retrieving revision 7.62
diff -b -u -r7.62 class.c
--- src/class.c	12 Apr 2004 16:22:19 -0000	7.62
+++ src/class.c	19 Aug 2004 22:16:31 -0000
@@ -305,8 +305,7 @@
 				ConFreq(cltmp), MaxUsers(cltmp), 
 				MaxSendq(cltmp), MaxSendqEob(cltmp),
 				MaxLocal(cltmp), MaxIdent(cltmp),
-				MaxGlobal(cltmp), MaxIdent(cltmp),
-				CurrUsers(cltmp));
+				   MaxGlobal(cltmp), MaxIdent(cltmp), CurrUsers(cltmp));
 	}
 
 	/* also output the default class */
